function InitializeBuffListener()

  buff_list.EffectAdded = function(sender, args)
    if setContains(bonus_buffs, buff_list:Get(args.Index):GetName()) then
      UpdateBonus()
    elseif setContains(outpost_buffs, buff_list:Get(args.Index):GetName()) then
      UpdateOutposts()
      end
  end

  buff_list.EffectRemoved = function(sender, args)
    if setContains(bonus_buffs, args.Effect:GetName()) then
      UpdateBonus()
    elseif setContains(outpost_buffs, args.Effect:GetName()) then
      UpdateOutposts()
    end
  end
  
  UpdateOutposts()
  UpdateBonus()
end

function UpdateBonus()
  local bonus  = 0
  local bonus1 = 0
  local bonus2 = 0
  
  for i = 1, buff_list:GetCount() do
    local element = buff_list:Get(i):GetName()
    if setContains(bonus_buffs, element) then
      bonus = bonus + bonus_buffs[element]
      
      if bonus % 10 == 3
      then
        bonus1 = 3
      end
      
      if bonus % 10 == 5
      then
        bonus2 = 5
      end
    end
  end

  bonus = bonus - bonus1 - bonus2
  
  overviewWindow.label_bonus:SetText(L.BuffWatcher_Bonus..bonus.."%")
  mapWindow:UpdateKeepsOnMap()
end

function UpdateOutposts()
  local bonus = 0
  local bonusChar = {}

  for i = 1, buff_list:GetCount() do
    local element = buff_list:Get(i):GetName()
    if setContains(outpost_buffs, element) then
  	  if ( element == "Coldfells Outpost" )
      then
        bonusChar[ bonus ] = "H"
      else
        bonusChar[ bonus ] = string.sub(element,0,1)
      end
      bonus = bonus + 1
    end
  end

  -- Set all OP bar colors to gray
  overviewWindow.outpost1:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))
  overviewWindow.outpost2:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))
  overviewWindow.outpost3:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))
  overviewWindow.outpost4:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))

  -- Set all OP bar text to blanks
  overviewWindow.outpost1Text:SetText( "" )
  overviewWindow.outpost2Text:SetText( "" )
  overviewWindow.outpost3Text:SetText( "" )
  overviewWindow.outpost4Text:SetText( "" )

  if bonus >= 1
  then
    overviewWindow.outpost1:SetBackColor(AlignmentColor)
    overviewWindow.outpost1Text:SetText(bonusChar[0])
  end
  if bonus >= 2
  then
    overviewWindow.outpost2:SetBackColor(AlignmentColor)
    overviewWindow.outpost2Text:SetText(bonusChar[1])
  end
  if bonus >= 3
  then
    overviewWindow.outpost3:SetBackColor(AlignmentColor)
    overviewWindow.outpost3Text:SetText(bonusChar[2])
  end
  if bonus == 4
  then
    overviewWindow.outpost4:SetBackColor(AlignmentColor)
    overviewWindow.outpost4Text:SetText(bonusChar[3])
  end

  mapWindow:UpdateKeepsOnMap()
end

function setContains(set, key)
    return set[key]
end
